

# ListSecurityProfilesForTarget
<a name="API_ListSecurityProfilesForTarget"></a>

**Note**  
The AWS IoT Device Defender detect feature will no longer be available to new customers starting August 31, 2026. If you would like to use the detect feature, sign up prior to August 31, 2026. To learn about alternatives to AWS IoT Device Defender detect, see [AWS IoT Device Defender detect feature availability change](https://docs.aws.amazon.com/iot-device-defender/latest/devguide/dd-detect-availability-change.html). There is no change to AWS IoT Device Defender audit availability.

Lists the Device Defender security profiles attached to a target (thing group).

Requires permission to access the [ListSecurityProfilesForTarget](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_ListSecurityProfilesForTarget_RequestSyntax"></a>

```
GET /security-profiles-for-target?maxResults={{maxResults}}&nextToken={{nextToken}}&recursive={{recursive}}&securityProfileTargetArn={{securityProfileTargetArn}} HTTP/1.1
```

## URI Request Parameters
<a name="API_ListSecurityProfilesForTarget_RequestParameters"></a>

The request uses the following URI parameters.

 ** [maxResults](#API_ListSecurityProfilesForTarget_RequestSyntax) **   <a name="iot-ListSecurityProfilesForTarget-request-uri-maxResults"></a>
The maximum number of results to return at one time.  
Valid Range: Minimum value of 1. Maximum value of 250.

 ** [nextToken](#API_ListSecurityProfilesForTarget_RequestSyntax) **   <a name="iot-ListSecurityProfilesForTarget-request-uri-nextToken"></a>
The token for the next set of results.

 ** [recursive](#API_ListSecurityProfilesForTarget_RequestSyntax) **   <a name="iot-ListSecurityProfilesForTarget-request-uri-recursive"></a>
If true, return child groups too.

 ** [securityProfileTargetArn](#API_ListSecurityProfilesForTarget_RequestSyntax) **   <a name="iot-ListSecurityProfilesForTarget-request-uri-securityProfileTargetArn"></a>
The ARN of the target (thing group) whose attached security profiles you want to get.  
Required: Yes

## Request Body
<a name="API_ListSecurityProfilesForTarget_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListSecurityProfilesForTarget_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "securityProfileTargetMappings": [ 
      { 
         "securityProfileIdentifier": { 
            "arn": "string",
            "name": "string"
         },
         "target": { 
            "arn": "string"
         }
      }
   ]
}
```

## Response Elements
<a name="API_ListSecurityProfilesForTarget_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_ListSecurityProfilesForTarget_ResponseSyntax) **   <a name="iot-ListSecurityProfilesForTarget-response-nextToken"></a>
A token that can be used to retrieve the next set of results, or `null` if there are no additional results.  
Type: String

 ** [securityProfileTargetMappings](#API_ListSecurityProfilesForTarget_ResponseSyntax) **   <a name="iot-ListSecurityProfilesForTarget-response-securityProfileTargetMappings"></a>
A list of security profiles and their associated targets.  
Type: Array of [SecurityProfileTargetMapping](API_SecurityProfileTargetMapping.md) objects

## Errors
<a name="API_ListSecurityProfilesForTarget_Errors"></a>

 ** InternalFailureException **   
An unexpected error has occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request is not valid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ThrottlingException **   
The rate exceeds the limit.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

## See Also
<a name="API_ListSecurityProfilesForTarget_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for C\+\+](https://docs.aws.amazon.com/goto/SdkForCpp/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iot-2015-05-28/ListSecurityProfilesForTarget) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iot-2015-05-28/ListSecurityProfilesForTarget) 